# Matrix

From ArchWiki
Jump to navigation Jump to search
The printable version is no longer supported and may have rendering errors. Please update your browser bookmarks and please use the default browser print function instead.

Matrix is an ambitious new ecosystem for open federated instant messaging and VoIP. It consists of servers, clients and bridge software to connect to existing messaging solutions like IRC.

A Matrix channel for Arch Linux exists at #archlinux:archlinux.org. Some international communities have their own matrix rooms; see International communities for details.

You can either use an existing server like https://matrix.org or host your own Synapse server, which is described below.

See List of applications#Matrix clients for a list of Matrix clients.

## Installation

The reference server implementation Synapse is available in the community repository as matrix-synapse. The community package creates a synapse user.

## Configuration

After installation, a configuration file needs to be generated. It should be readable by the synapse user:

    $ cd /var/lib/synapse
    $ sudo -u synapse python -m synapse.app.homeserver \
      --server-name my.domain.name \
      --config-path /etc/synapse/homeserver.yaml \
      --generate-config \
      --report-stats=yes

Note that this will generate corresponding SSL keys and self-signed certificates for the specified server name. You have to regenerate those if you change the server name.

If your Synapse server is meant to be accessed over the internet, it is highly recommended to configure a reverse proxy.

## Service

The `synapse.service` systemd service is included in the matrix-synapse package. It will start the synapse server as user synapse and use the configuration file `/etc/synapse/homeserver.yaml`.

## User management

You need at least one user on your fresh synapse server. You may create one as your normal non-root user with the command

    $ register_new_matrix_user -c /etc/synapse/homeserver.yaml http://127.0.0.1:8008

or using one of the matrix clients, for example element-desktop, or the purple-matrix-gitAUR plug-in for libpurple.

## Spider Webcrawler

To enable the webcrawler, for server generated link previews, the additional packages python-lxml and python-netaddr have to be installed. After that the config option `url_preview_enabled: True` can be set in your `homeserver.yaml`. To prevent the synapse server from issuing arbitrary GET requests to internal hosts the `url_preview_ip_range_blacklist:` has to be set.

Warning: There are no defaults! By default the synapse server can crawl all your internal hosts.

There are some examples that can be uncommented. Add your local IP ranges to that list to prevent the synapse server from trying to crawl them. After changing the `homeserver.yaml` the service has to be restarted.

## Interesting channels

KDE community has a wide variety of matrix rooms for specific applications, languages, events and etc. See [1] for details.

Categories:

- Instant messaging
- Voice over IP